unit main;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ActnList,
  StdActns,
  ToolWin,
  ActnMan,
  ActnCtrls,
  ActnMenus,
  StdCtrls,
  ImgList,
  ComCtrls,
  ExtActns,
  XPStyleActnCtrls,
  BandActn,
  StdStyleActnCtrls,
  ExtCtrls,
  Menus,
  ShellAPI,
  ActnPopupCtrl,
  Buttons,
  cCiaOnlyOne,
  Spin,
  RXSpin,
  TeEngine,
  Series,
  TeeProcs,
  Chart,
  GanttCh,
  TeeShape,
  OleCtrls,
  SHDocVw,
  StrUtils,
  Registry,
  IniFiles,
  Reg;

type
  TMainForm = class(TForm)
    ActionManager1: TActionManager;
    MainMenu: TActionMainMenuBar;
    ToolBar: TActionToolBar;
    ImageList: TImageList;
    FileExit1: TFileExit;
    LeftMenuBar: TActionToolBar;
    BasePanel: TPanel;
    About: TAction;
    Notebook: TNotebook;
    PopupActionBarEx1: TPopupActionBarEx;
    gu1: TMenuItem;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText5: TStaticText;
    VisitWWW: TAction;
    SendMail: TAction;
    Action3: TAction;
    ImageList1: TImageList;
    ActionManager2: TActionManager;
    Action2: TAction;
    Action4: TAction;
    Action5: TAction;
    Action6: TAction;
    Action7: TAction;
    CiaOnlyOne1: TCiaOnlyOne;
    ActionsToolBar: TActionToolBar;
    Label8: TLabel;
    StaticText8: TStaticText;
    ListView1: TListView;
    CheckBox1: TCheckBox;
    GroupBox5: TGroupBox;
    Label10: TLabel;
    RxSpinEdit2: TRxSpinEdit;
    Label11: TLabel;
    RxSpinEdit3: TRxSpinEdit;
    Label9: TLabel;
    RxSpinEdit1: TRxSpinEdit;
    Action8: TAction;
    ActionToolBar1: TActionToolBar;
    Action9: TAction;
    Action10: TAction;
    Action11: TAction;
    StatusBar1: TStatusBar;
    CadenceChart: TChart;
    ON_1_Max: TChartShape;
    OFF_1_Max: TChartShape;
    ON_2_Max: TChartShape;
    OFF_2_Max: TChartShape;
    ComboBox1: TComboBox;
    TonesTree: TTreeView;
    Label15: TLabel;
    RxSpinEdit4: TRxSpinEdit;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    RxSpinEdit5: TRxSpinEdit;
    RxSpinEdit6: TRxSpinEdit;
    RxSpinEdit7: TRxSpinEdit;
    ON_1_Min: TChartShape;
    ON_2_Min: TChartShape;
    OFF_1_Min: TChartShape;
    OFF_2_Min: TChartShape;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    Label31: TLabel;
    Label32: TLabel;
    StaticText13: TStaticText;
    StaticText14: TStaticText;
    Label33: TLabel;
    Label34: TLabel;
    GroupBox8: TGroupBox;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    RxSpinEdit14: TRxSpinEdit;
    RxSpinEdit15: TRxSpinEdit;
    Label38: TLabel;
    RxSpinEdit16: TRxSpinEdit;
    Label39: TLabel;
    Action12: TAction;
    GroupBox7: TGroupBox;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    RxSpinEdit12: TRxSpinEdit;
    RxSpinEdit13: TRxSpinEdit;
    Label25: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    RxSpinEdit17: TRxSpinEdit;
    RxSpinEdit18: TRxSpinEdit;
    Label42: TLabel;
    ListView4: TListView;
    Label44: TLabel;
    RxSpinEdit19: TRxSpinEdit;
    Label45: TLabel;
    RxSpinEdit20: TRxSpinEdit;
    Label46: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    GroupBox2: TGroupBox;
    Label12: TLabel;
    ListView3: TListView;
    ActionToolBar3: TActionToolBar;
    Memo2: TMemo;
    Label14: TLabel;
    StaticText15: TStaticText;
    Action13: TAction;
    Label3: TLabel;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    Label4: TLabel;
    Label6: TLabel;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    Label7: TLabel;
    StaticText9: TStaticText;
    Label13: TLabel;
    RxSpinEdit8: TRxSpinEdit;
    Action1: TAction;
    Action14: TAction;
    Action15: TAction;
    Action16: TAction;
    Action17: TAction;
    Label20: TLabel;
    Memo1: TMemo;
    Label29: TLabel;
    StaticText10: TStaticText;
    Label30: TLabel;
    StaticText16: TStaticText;
    Label43: TLabel;
    StaticText17: TStaticText;
    Label47: TLabel;
    StaticText18: TStaticText;
    Label48: TLabel;
    StaticText19: TStaticText;
    Label49: TLabel;
    StaticText20: TStaticText;
    Action18: TAction;
    Action19: TAction;
    Action20: TAction;
    procedure OpenGeneral(Sender: TObject);
    procedure VisitHomepage(Sender: TObject);
    procedure SendEMail(Sender: TObject);
    procedure OpenTransmit(Sender: TObject);
    procedure OpenBlacklist(Sender: TObject);
    procedure OpenSignals(Sender: TObject);
    procedure OpenCounries(Sender: TObject);
    procedure OpenModemLogs(Sender: TObject);
    procedure RequestBlacklistedNumbers(Sender: TObject);
    procedure RequestBlacklistedParams(Sender: TObject);
    procedure ChangeBlacklistParams(Sender: TObject);
    procedure GetCountriesList(Sender: TObject);
    procedure ListView3SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure SetCountry(Sender: TObject);
    procedure ChartRepaint(Sender: TObject);
    procedure OpenTiming(Sender: TObject);
    procedure GetRegisters(Sender: TObject);
    procedure ListView4SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure GetUserInit(Sender: TObject);
    procedure Action13Execute(Sender: TObject);
    procedure ShowOtherInfo(Sender: TObject);
    procedure ReadTransmit(Sender: TObject);
    procedure GetSignals(Sender: TObject);
    procedure TonesTreeGetSelectedIndex(Sender: TObject; Node: TTreeNode);
    procedure ChangeSignals(Sender: TObject);
    procedure GetTimingParams(Sender: TObject);
    procedure SaveCurrent(Sender: TObject);
    procedure ChangeTransmit(Sender: TObject);
    procedure ChangeTimingParams(Sender: TObject);
    procedure ChangeRegs(Sender: TObject);
    procedure Autodetect(Sender: TObject);
    procedure Initialize(Sender: TObject);
    procedure ResetAll(Sender: TObject);
    procedure ResetCurrent(Sender: TObject);
    procedure LoadGeneral(Sender: TObject);
    procedure LoadCountries(Sender: TObject);
    procedure LoadTransmit(Sender: TObject);
    procedure LoadSignals(Sender: TObject);
    procedure LoadTiming(Sender: TObject);
    procedure LoadBlacklist(Sender: TObject);
    procedure OpenAbout(Sender: TObject);
    procedure SaveTiming(Sender: TObject);
    procedure SaveAll(Sender: TObject);
    function DetectPlatform: Integer;
    procedure DisableApplication(Sender: TObject);
    procedure Report(Sender: TObject);
    procedure CloseNeoBlue(Sender: TObject; var CanClose: Boolean);
    procedure LoadParams(Sender: TObject);
    procedure TryRegister(Sender: TObject);
    procedure Action20Execute(Sender: TObject);

  private
  public
    { Public declarations }
  end;

  TPassKey = record
    Reg: ShortString;
    Port: Byte;
  end;

  TBlackList = record
    Status: byte;          // 0-blocked, 1-delayed, 2-free
    Phone: ShortString;    // Phone Number
    Delay: ShortString;    // Delay Time
    Attempts: ShortString; // Number of Attempts
  end;
  TList = array of TBlackList;

  TCountry = record
    ExactName: ShortString;
    MyName: ShortString;
    Code: Byte;
    Flag: Byte;
    Diz: String;
    Reserved: String;
  end;
  TCountryList = Array of TCountry;

  TRegister = record
    Name: ShortString;
    Number: Integer;
    Value: Integer;
    MinValue: Integer;
    MaxValue: Integer;
    Useful: Boolean;
    Diz: String;
  end;
  TRegisters = Array of TRegister;
  TTransmit = record
    TX_Data: Byte;
    TX_Fax: Byte;
    TX_Voice: Byte;
    TX_V90: Byte;
    TX_V92_1: Boolean;
    TX_V92_2: Boolean;
    TX_V92_3: Boolean;
    TX_V92_4: Boolean;
    TX_FData: Boolean;
    TX_FFax: Boolean;
    TX_FVoice: Boolean;
    TX_FV90: Boolean;
    TX_FV92_1: Boolean;
    TX_FV92_2: Boolean;
    TX_FV92_3: Boolean;
    TX_FV92_4: Boolean;
  end;
  TSignal = record
    Name: ShortString;
    Cycles: Byte;
    Filter: Byte;
    MinON: Byte;
    MaxON: Byte;
    MinOFF: Byte;
    MaxOFF: Byte;
  end;
  TSignals = Array [0..3] of TSignal;

const
  SupportPage: ShortString = 'www.neoblue.tk';
  SupportMail: ShortString = 'support@neoblue.tk';
  Settings: ShortString = 'nbsl.ini';
  WinNT_ModemKey: ShortString = '\SYSTEM\CurrentControlSet\Control\Class\{4D36E96D-E325-11CE-BFC1-08002BE10318}';
  Win9X_ModemKey: ShortString = '\System\CurrentControlSet\Services\Class\Modem';

var
  MainForm: TMainForm;
  PassKey: TPassKey = (Reg: '\SYSTEM\CurrentControlSet\Control\Class\{4D36E96D-E325-11CE-BFC1-08002BE10318}\0000'; Port: 3);
  UserName: PChar;
  //CurrentModemKey: ShortString = '\SYSTEM\CurrentControlSet\Control\Class\{4D36E96D-E325-11CE-BFC1-08002BE10318}\0000';
  Countries: TCountryList;
  Regs: TRegisters;
  Signals: TSignals;
  StringBuffer: String;
  // Transmit Variables
  Trans: TTransmit;
  // Blacklisting Variables
  tmpBL_Enabled: boolean;
  tmpAttempts, tmpTimeout, tmpDuration: byte;
  // Timing Variables
  DT1, DT2, A1, A2, A1_min, A1_max: byte;
  RegsAmount: Byte;
  Changed_Transmit:  Boolean = False;
  Changed_Signals:   Boolean = False;
  Changed_Timing:    Boolean = False;
  Changed_Blacklist: Boolean = False;

implementation

//uses Unit1;

{$R *.dfm}

function GetPluginInfo: ShortString; stdcall; external 'Plugins\SL.dll';
function GetModemModel(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetHardwareID(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetCurrentCountry(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetLoggingPath(Key: TPassKey; var Path: String): boolean ; stdcall; external 'Plugins\SL.dll';
function SendAT(Key: TPassKey; AT: ShortString): String; stdcall; external 'Plugins\SL.dll';
function GetBlacklist(Key: TPassKey; var BL: TList): integer; stdcall; external 'Plugins\SL.dll';
function DualBlacklistParams(Key: TPassKey; Store: boolean; var BL_Enabled: boolean; var Attempts, Timeout, Duration: byte): boolean; stdcall; external 'Plugins\SL.dll';
function GetCountries(Key: TPassKey; var Countries: TCountryList): integer; stdcall; external 'Plugins\SL.dll';
function SetCurrentCountry(Key: TPassKey; Country: TCountry): Boolean; stdcall; external 'Plugins\SL.dll';
procedure DualRegisters(Key: TPassKey; Store: boolean; var Regs: TRegisters; var RegsAmount: byte); stdcall; external 'Plugins\SL.dll';
function DualUserInit(Key: TPassKey; var Init: ShortString; Store: Boolean): Boolean; stdcall; external 'Plugins\SL.dll';
function GetCOMPort(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetDriverVersion(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetInfoChipset(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetInfoAC(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetInfoMC(Key: TPassKey): ShortString; stdcall; external 'Plugins\SL.dll';
function GetOtherInfo(Key: TPassKey; var In1, In2, In3, In4: ShortString): Boolean; stdcall; external 'Plugins\SL.dll';
function GetTransmit(Key: TPassKey; var Trans: TTransmit): Boolean; stdcall; external 'Plugins\SL.dll';
procedure DualSignals(Key: TPassKey; var Signals: TSignals; Store: Boolean); stdcall; external 'Plugins\SL.dll';
function DualTiming(Key: TPassKey; var DT1, DT2, A1, A2, A1_min, A1_max: byte; Store: Boolean): Boolean; stdcall; external 'Plugins\SL.dll';
function SetTransmit(Key: TPassKey; var Trans: TTransmit): Boolean; stdcall; external 'Plugins\SL.dll';


//-------------------------------------------------

procedure TMainForm.Autodetect(Sender: TObject);
var
  I: Byte;
  Reg: TRegistry;
begin
  case DetectPlatform of
    VER_PLATFORM_WIN32s:
      begin
        DisableApplication(Self);
        ShowMessage('Sorry, but Windows 3.* is not supported. The application is disabled.');
      end;
    VER_PLATFORM_WIN32_WINDOWS: PassKey.Reg := Win9X_ModemKey;
    VER_PLATFORM_WIN32_NT: PassKey.Reg := WinNT_ModemKey;
  end;
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    for I := 0 to 99 do
    begin
      case I of
        0..9: StringBuffer := PassKey.Reg + '\000' + IntToStr(I) + '\HostBasedModemData\Parameters\DPDriver\Country\HomologationParameters';
        else StringBuffer := PassKey.Reg + '\00' + IntToStr(I) + '\HostBasedModemData\Parameters\DPDriver\Country\HomologationParameters';
      end;
      if Reg.OpenKeyReadOnly(StringBuffer) then Break;
    end;
  finally
    Reg.Free;
  end;
  case I of
    0..9: PassKey.Reg := PassKey.Reg + '\000' + IntToStr(I);
    else PassKey.Reg := PassKey.Reg + '\00' + IntToStr(I);
  end;
  if (GetCOMPort(PassKey) <> '') then
  begin
    StatusBar1.Panels[2].Text := GetCOMPort(PassKey);
    PassKey.Port := StrToInt(StatusBar1.Panels[2].Text[4])
  end
  else
  begin
    Action8.Enabled := False;
    ShowMessage('The program cannot find available COM ports. Please contact producer.');
  end;
  // Plugin
  StatusBar1.Panels[0].Text := 'Plugin: ' + GetPluginInfo;
  StaticText18.Caption := GetPluginInfo;
  {$I include\reg_crypt_begin.inc}
  StaticText17.Caption := StrPas(UserName);
  Action1.Enabled := True;
  Action14.Enabled := True;
  {$I include\reg_crypt_end.inc}
  LoadParams(Self);
end;

procedure TMainForm.VisitHomepage(Sender: TObject);
begin
  try
    ShellExecute(Handle,'open',pChar('http://'+SupportPage),'','',SW_SHOWNORMAL);
  except
    MessageDlg('Cannot open default mail browser!'+#13#10+'You can visit '+SupportPage, mtError, [mbOK], 0);
  end;
end;

procedure TMainForm.SendEMail(Sender: TObject);
begin
  try
    ShellExecute(Handle,'open',pChar('mailto:'+SupportMail),'','',SW_SHOWNORMAL);
  except
    MessageDlg('Cannot open default mail client!'+#13#10+'You can contact '+SupportMail, mtError, [mbOK], 0);
  end;
end;

procedure TMainForm.OpenGeneral(Sender: TObject);
begin
  Notebook.ActivePage := 'PGeneral';
end;

procedure TMainForm.OpenCounries(Sender: TObject);
begin
  Notebook.ActivePage := 'PCountries';
end;

procedure TMainForm.OpenTransmit(Sender: TObject);
begin
  Notebook.ActivePage := 'PTransmit';
end;

procedure TMainForm.OpenSignals(Sender: TObject);
begin
  Notebook.ActivePage := 'PSignals';
end;

procedure TMainForm.OpenTiming(Sender: TObject);
begin
  Notebook.ActivePage := 'PTiming';
end;

procedure TMainForm.OpenBlacklist(Sender: TObject);
begin
  Notebook.ActivePage := 'PBlacklist';
end;

procedure TMainForm.OpenAbout(Sender: TObject);
begin
  Notebook.ActivePage := 'PAbout';
end;

procedure TMainForm.OpenModemLogs(Sender: TObject);
begin
  if GetLoggingPath(PassKey, StringBuffer) then
  ShellExecute(Handle,'open',pChar(StringBuffer),'','',SW_SHOWNORMAL);
end;

procedure TMainForm.RequestBlacklistedNumbers(Sender: TObject);
var
  BL: TList;
  J: integer;
  Item: TListItem;
begin
  ListView1.Items.Clear;
  ListView1.Repaint;
  for J := 0 to GetBlacklist(PassKey, BL)-1 do
  begin
    Item := ListView1.Items.Add;
    Item.Caption := BL[J].Phone;
    Item.ImageIndex := BL[J].Status + 19;
    Item.SubItems.Add(BL[J].Attempts);
    Item.SubItems.Add(BL[J].Delay);
  end;
end;

procedure TMainForm.RequestBlacklistedParams(Sender: TObject);
begin
  CheckBox1.OnClick := nil;
  RxSpinEdit1.OnChange := nil;
  RxSpinEdit2.OnChange := nil;
  RxSpinEdit3.OnChange := nil;

  DualBlacklistParams(PassKey, False, tmpBL_Enabled, tmpAttempts, tmpTimeout, tmpDuration);
  RxSpinEdit1.Value := tmpAttempts;
  RxSpinEdit3.Value := tmpTimeout;
  RxSpinEdit2.Value := tmpDuration;
  CheckBox1.Checked := tmpBL_Enabled;

  CheckBox1.OnClick := ChangeBlacklistParams;
  RxSpinEdit1.OnChange := ChangeBlacklistParams;
  RxSpinEdit2.OnChange := ChangeBlacklistParams;
  RxSpinEdit3.OnChange := ChangeBlacklistParams;
end;

procedure TMainForm.ChangeBlacklistParams(Sender: TObject);
begin
  Label9.Enabled := CheckBox1.Checked;
  Label10.Enabled := CheckBox1.Checked;
  Label11.Enabled := CheckBox1.Checked;
  RxSpinEdit1.Enabled := CheckBox1.Checked;
  RxSpinEdit2.Enabled := CheckBox1.Checked;
  RxSpinEdit3.Enabled := CheckBox1.Checked;

  tmpBL_Enabled := CheckBox1.Checked;
  tmpAttempts := RxSpinEdit1.AsInteger;
  tmpTimeout := RxSpinEdit3.AsInteger;
  tmpDuration := RxSpinEdit2.AsInteger;


end;

procedure TMainForm.GetCountriesList(Sender: TObject);
var
  I: integer;
  Item: TListItem;
begin
  ListView3.Items.Clear;
  Memo2.Lines.Clear;
  ListView3.Repaint;
  GetCountries(PassKey, Countries);
  for I := 0 to (GetCountries(PassKey, Countries) - 1) do
  begin
    Item := ListView3.Items.Add;
    //Item.Caption := Countries[I].ExactName + ' [' + IntToStr(Countries[I].Code) + ']';
    //Item.Caption := T35_CountryCode[Countries[I].Code] + ' [' + Countries[I].ExactName + ']';
    Item.Caption := Countries[I].MyName;
    Item.ImageIndex := Countries[I].Flag + 31;
  end;
  if ListView3.Items.Count > 10 then ListView3.Columns[0].Width := ListView3.Width - 18
  else ListView3.Columns[0].Width := ListView3.Width - 2;
end;

procedure TMainForm.ListView3SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  Memo2.Lines.Clear;
  Memo2.Lines.Text := Countries[Item.Index].Diz;
end;

procedure TMainForm.SetCountry(Sender: TObject);
begin
  if ListView3.Selected = nil then MessageDlg('Select a country from the list.', mtWarning, [mbOk], 0)
  else
  begin
    if MessageDlg('Are you sure to change modem''s current country?', mtConfirmation, [mbYes, mbCancel], 0) = mrYes then
    begin
      SetCurrentCountry(PassKey, Countries[ListView3.Selected.Index]);
      ResetAll(Self);
    end;
  end;
end;

procedure TMainForm.ChartRepaint(Sender: TObject);
begin
  With ON_1_Max do
  begin
    X0:= 0;
    X1:= RxSpinEdit5.Value;
    Y0:= 0;
    Y1:= 8;
  end;
  With ON_1_Min do
  begin
    X0:= 0;
    X1:= RxSpinEdit8.Value;
    Y0:= 0;
    Y1:= 8;
  end;
  With ON_2_Max do
  begin
    X0:= RxSpinEdit5.Value + RxSpinEdit7.Value;
    X1:= X0 + RxSpinEdit5.Value;
    Y0:= 0;
    Y1:= 8;
  end;
  With ON_2_Min do
  begin
    X0:= RxSpinEdit5.Value + RxSpinEdit7.Value;
    X1:= X0 + RxSpinEdit8.Value;
    Y0:= 0;
    Y1:= 8;
  end;
  With OFF_1_Max do
  begin
    X0:= RxSpinEdit5.Value;
    X1:= X0 + RxSpinEdit7.Value;
    Y0:= 0;
    Y1:= 8;
  end;
  With OFF_1_Min do
  begin
    X0:= RxSpinEdit5.Value;
    X1:= X0 + RxSpinEdit6.Value;
    Y0:= 0;
    Y1:= 8;
  end;
  With OFF_2_Max do
  begin
    X0:= 2 * RxSpinEdit5.Value + RxSpinEdit7.Value;
    X1:= X0 + RxSpinEdit7.Value;
    Y0:= 0;
    Y1:= 8;
  end;
  With OFF_2_Min do
  begin
    X0:= 2 * RxSpinEdit5.Value + RxSpinEdit7.Value;
    X1:= X0 + RxSpinEdit6.Value;
    Y0:= 0;
    Y1:= 8;
  end;
end;

procedure TMainForm.GetRegisters(Sender: TObject);
var
  I: Integer;
  Item: TListItem;
begin
  ListView4.Items.Clear;
  ListView4.Refresh; // .Repaint;
  Label44.Caption := 'Please, select a register from the list below';
  RxSpinEdit19.OnChange := nil;
  RxSpinEdit19.Value := 0;
  RxSpinEdit19.OnChange := ChangeRegs;
  //RxSpinEdit19.Enabled := False;
  DualRegisters(PassKey, False, Regs, RegsAmount);
  for I := 0 to RegsAmount do
  begin
    Item := ListView4.Items.Add;
    Item.Caption := Regs[I].Name;
    Item.SubItems.Add(IntToStr(Regs[I].Value));
    //if Regs[I].Useful then Item.ImageIndex := 23 else Item.ImageIndex := 24;
    Item.ImageIndex := 23
  end;
  if ListView4.Items.Count > 7 then ListView4.Columns[0].Width := 152
  else ListView4.Columns[0].Width := 168;
end;

procedure TMainForm.ListView4SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  Label44.Caption := 'Changing Value of the Register ' + Regs[Item.Index].Name;
  RxSpinEdit19.Value := Regs[Item.Index].Value;
end;

procedure TMainForm.GetUserInit(Sender: TObject);
var
  Init: ShortString;
begin
  if DualUserInit(PassKey, Init, False) then StaticText11.Caption := Init else StaticText11.Caption := '';
end;

procedure TMainForm.Action13Execute(Sender: TObject);
var
  Init: ShortString;
begin
  Init := InputBox(GetModemModel(PassKey), 'WARNING!'+#13#10+'Uncorrect Init String can disable the modem!', StaticText11.Caption);
  DualUserInit(PassKey, Init, True);
  GetUserInit(Sender);
end;

procedure TMainForm.ShowOtherInfo(Sender: TObject);
var
  In1, In2, In3, In4: ShortString;
begin
  GetOtherInfo(PassKey, In1, In2, In3, In4);
  StaticText4.Caption := In1;
  StaticText6.Caption := In2;
  StaticText7.Caption := In3;
  StaticText9.Caption := In4;
end;

procedure TMainForm.ReadTransmit(Sender: TObject);
begin
  GetTransmit(PassKey, Trans);

  RxSpinEdit14.OnChange := nil;
  RxSpinEdit15.OnChange := nil;
  RxSpinEdit16.OnChange := nil;
  RxSpinEdit20.OnChange := nil;
  CheckBox2.OnClick := nil;
  CheckBox3.OnClick := nil;
  CheckBox4.OnClick := nil;
  CheckBox5.OnClick := nil;

  RxSpinEdit14.Value := 0 - Trans.TX_Data;
  RxSpinEdit15.Value := 0 - Trans.TX_Fax;
  RxSpinEdit16.Value := 0 - Trans.TX_Voice;
  RxSpinEdit20.Value := 0 - Trans.TX_V90;
  CheckBox2.Enabled := Trans.TX_FV92_1;
  if Trans.TX_FV92_1 then CheckBox2.Checked := Trans.TX_V92_1;
  CheckBox3.Enabled := Trans.TX_FV92_2;
  if Trans.TX_FV92_2 then CheckBox3.Checked := Trans.TX_V92_2;
  CheckBox4.Enabled := Trans.TX_FV92_3;
  if Trans.TX_FV92_3 then CheckBox4.Checked := Trans.TX_V92_3;
  CheckBox5.Enabled := Trans.TX_FV92_4;
  if Trans.TX_FV92_4 then CheckBox5.Checked := Trans.TX_V92_4;

  RxSpinEdit14.OnChange := ChangeTransmit;
  RxSpinEdit15.OnChange := ChangeTransmit;
  RxSpinEdit16.OnChange := ChangeTransmit;
  RxSpinEdit20.OnChange := ChangeTransmit;
  CheckBox2.OnClick := ChangeTransmit;
  CheckBox3.OnClick := ChangeTransmit;
  CheckBox4.OnClick := ChangeTransmit;
  CheckBox5.OnClick := ChangeTransmit;
end;

procedure TMainForm.GetSignals(Sender: TObject);
begin
  DualSignals(PassKey, Signals, False);
end;

procedure TMainForm.TonesTreeGetSelectedIndex(Sender: TObject;
  Node: TTreeNode);
begin
  if Node <> nil then
  begin
   if Node.AbsoluteIndex = 0 then
    begin
     RxSpinEdit4.Enabled := False;
     ComboBox1.Enabled := False;
      RxSpinEdit8.Enabled := False;
      RxSpinEdit5.Enabled := False;
      RxSpinEdit6.Enabled := False;
      RxSpinEdit7.Enabled := False;

      RxSpinEdit4.OnChange := nil;
      ComboBox1.OnChange := nil;
      RxSpinEdit8.OnChange := nil;
      RxSpinEdit5.OnChange := nil;
      RxSpinEdit6.OnChange := nil;
      RxSpinEdit7.OnChange := nil;

      RxSpinEdit4.Value := 0;
      ComboBox1.ItemIndex := 0;
      RxSpinEdit8.Value := 0;
      RxSpinEdit5.Value := 0;
      RxSpinEdit6.Value := 0;
      RxSpinEdit7.Value := 0;

      RxSpinEdit4.OnChange := ChangeSignals;
      ComboBox1.OnChange := ChangeSignals;
      RxSpinEdit8.OnChange := ChangeSignals;
      RxSpinEdit5.OnChange := ChangeSignals;
      RxSpinEdit6.OnChange := ChangeSignals;
      RxSpinEdit7.OnChange := ChangeSignals;

      ChartRepaint(Sender);
    end
    else
    begin
      RxSpinEdit4.Enabled := True;
      ComboBox1.Enabled := True;
      RxSpinEdit8.Enabled := True;
      RxSpinEdit5.Enabled := True;
      RxSpinEdit6.Enabled := True;
      RxSpinEdit7.Enabled := True;

      RxSpinEdit4.OnChange := nil;
      ComboBox1.OnChange := nil;
      RxSpinEdit8.OnChange := nil;
      RxSpinEdit5.OnChange := nil;
      RxSpinEdit6.OnChange := nil;
      RxSpinEdit7.OnChange := nil;

      RxSpinEdit4.Value := Signals[Node.AbsoluteIndex - 1].Cycles;
      ComboBox1.ItemIndex := Signals[Node.AbsoluteIndex - 1].Filter;
      RxSpinEdit8.Value := Signals[Node.AbsoluteIndex - 1].MinON * 10;
      RxSpinEdit5.Value := Signals[Node.AbsoluteIndex - 1].MaxON * 10;
      RxSpinEdit6.Value := Signals[Node.AbsoluteIndex - 1].MinOFF * 10;
      RxSpinEdit7.Value := Signals[Node.AbsoluteIndex - 1].MaxOFF * 10;

      RxSpinEdit4.OnChange := ChangeSignals;
      ComboBox1.OnChange := ChangeSignals;
      RxSpinEdit8.OnChange := ChangeSignals;
      RxSpinEdit5.OnChange := ChangeSignals;
      RxSpinEdit6.OnChange := ChangeSignals;
      RxSpinEdit7.OnChange := ChangeSignals;

      ChartRepaint(Sender);
    end;
  end;
end;

procedure TMainForm.ChangeSignals(Sender: TObject);
begin
  //if (TonesTree.Selected = nil) then
  //begin
    Signals[TonesTree.Selected.AbsoluteIndex - 1].Cycles := RxSpinEdit4.AsInteger;
    Signals[TonesTree.Selected.AbsoluteIndex - 1].Filter := ComboBox1.ItemIndex;
    Signals[TonesTree.Selected.AbsoluteIndex - 1].MinON := RxSpinEdit8.AsInteger div 10;
    Signals[TonesTree.Selected.AbsoluteIndex - 1].MaxON := RxSpinEdit5.AsInteger div 10;
    Signals[TonesTree.Selected.AbsoluteIndex - 1].MinOFF := RxSpinEdit6.AsInteger div 10;
    Signals[TonesTree.Selected.AbsoluteIndex - 1].MaxOFF := RxSpinEdit7.AsInteger div 10;
    ChartRepaint(Sender);
  //end;
end;

procedure TMainForm.GetTimingParams(Sender: TObject);
begin
  DualTiming(PassKey, DT1, DT2, A1, A2, A1_min, A1_max, False);

  RxSpinEdit12.OnChange := nil;
  RxSpinEdit13.OnChange := nil;
  RxSpinEdit17.OnChange := nil;
  RxSpinEdit18.OnChange := nil;

  RxSpinEdit12.Value := DT1;
  RxSpinEdit13.Value := DT2;
  RxSpinEdit17.Value := A1;
  RxSpinEdit18.Value := A2;
  RxSpinEdit17.MinValue := A1_min;
  RxSpinEdit17.MaxValue := A1_max;

  RxSpinEdit12.OnChange := ChangeTimingParams;
  RxSpinEdit13.OnChange := ChangeTimingParams;
  RxSpinEdit17.OnChange := ChangeTimingParams;
  RxSpinEdit18.OnChange := ChangeTimingParams;
end;

procedure TMainForm.SaveCurrent(Sender: TObject);
begin
  {$I include\reg_crypt_begin.inc}
  if (Notebook.ActivePage = 'PTransmit') then SetTransmit(PassKey, Trans);
  if (Notebook.ActivePage = 'PSignals') then DualSignals(PassKey, Signals, True);
  if (Notebook.ActivePage = 'PTiming') then SaveTiming(Sender);
  if (Notebook.ActivePage = 'PBlacklist') then DualBlacklistParams(PassKey, True, tmpBL_Enabled, tmpAttempts, tmpTimeout, tmpDuration);
  {$I include\reg_crypt_end.inc}
end;

procedure TMainForm.ChangeTransmit(Sender: TObject);
begin
  Trans.TX_Data := 0 - RxSpinEdit14.AsInteger;
  Trans.TX_Fax := 0 - RxSpinEdit15.AsInteger;
  Trans.TX_Voice := 0 - RxSpinEdit16.AsInteger;
  Trans.TX_V90 := 0 - RxSpinEdit20.AsInteger;
  Trans.TX_V92_1 := CheckBox2.Checked;
  Trans.TX_V92_2 := CheckBox3.Checked;
  Trans.TX_V92_3 := CheckBox4.Checked;
  Trans.TX_V92_4 := CheckBox5.Checked;
end;

procedure TMainForm.ChangeTimingParams(Sender: TObject);
begin
  DT1 := RxSpinEdit12.AsInteger;
  DT2 := RxSpinEdit13.AsInteger;
  A1 := RxSpinEdit17.AsInteger;
  A2 := RxSpinEdit18.AsInteger;
end;

procedure TMainForm.ChangeRegs(Sender: TObject);
begin
  if ListView4.Selected = nil then MessageDlg('Select a register from the list.', mtWarning, [mbOk], 0)
  else
  begin
    Regs[ListView4.ItemIndex].Value := RxSpinEdit19.AsInteger;
    ListView4.Items.Item[ListView4.ItemIndex].SubItems.Insert(0, IntToStr(Regs[ListView4.ItemIndex].Value));//  .Add('000');
  end;
end;

procedure TMainForm.Initialize(Sender: TObject);
begin
  //beep;
end;

procedure TMainForm.ResetAll(Sender: TObject);
begin
  LoadGeneral(Sender);
  LoadCountries(Sender);
  LoadTransmit(Sender);
  LoadSignals(Sender);
  LoadTiming(Sender);
  LoadBlacklist(Sender);
end;

procedure TMainForm.ResetCurrent(Sender: TObject);
begin
  if (Notebook.ActivePage = 'PGeneral') then LoadGeneral(Sender);
  if (Notebook.ActivePage = 'PCountries') then LoadCountries(Sender);
  if (Notebook.ActivePage = 'PTransmit') then LoadTransmit(Sender);
  if (Notebook.ActivePage = 'PSignals') then LoadSignals(Sender);
  if (Notebook.ActivePage = 'PTiming') then LoadTiming(Sender);
  if (Notebook.ActivePage = 'PBlacklist') then LoadBlacklist(Sender);
end;

procedure TMainForm.LoadGeneral(Sender: TObject);
begin
  StaticText1.Caption := GetModemModel(PassKey);
  StaticText5.Caption := GetHardwareID(PassKey);
  GetUserInit(Sender);
  StaticText2.Caption := GetCurrentCountry(PassKey);
  StatusBar1.Panels[1].Text := 'Country: ' + StaticText2.Caption;
  StaticText8.Caption := GetCOMPort(PassKey);
  StaticText12.Caption := GetDriverVersion(PassKey);
  StaticText14.Caption := GetInfoChipset(PassKey);
  StaticText3.Caption := GetInfoMC(PassKey);
  StaticText13.Caption := GetInfoAC(PassKey);
  ShowOtherInfo(Sender);
  if GetLoggingPath(PassKey, StringBuffer) then
  Action3.Enabled := True else Action3.Enabled := False;
end;

procedure TMainForm.LoadCountries(Sender: TObject);
begin
  StaticText15.Caption := GetCurrentCountry(PassKey);
  GetCountriesList(Sender);
end;

procedure TMainForm.LoadTransmit(Sender: TObject);
begin
  ReadTransmit(Sender);
end;

procedure TMainForm.LoadSignals(Sender: TObject);
begin
  GetSignals(Self);
  //ChangeSignals(Self);
  if TonesTree.Selected <> nil then TonesTreeGetSelectedIndex(Sender, TonesTree.Selected)
  else TonesTreeGetSelectedIndex(Sender, nil);
end;

procedure TMainForm.LoadTiming(Sender: TObject);
begin
  GetTimingParams(Sender);
  GetRegisters(Sender);
end;

procedure TMainForm.LoadBlacklist(Sender: TObject);
begin
  RequestBlacklistedParams(Self);
  ChangeBlacklistParams(Self);
end;

procedure TMainForm.SaveTiming(Sender: TObject);
begin
  DualTiming(PassKey, DT1, DT2, A1, A2, A1_min, A1_max, True);
  DualRegisters(PassKey, True, Regs, RegsAmount);
end;

procedure TMainForm.SaveAll(Sender: TObject);
begin
  {$I include\reg_crypt_begin.inc}
  SetTransmit(PassKey, Trans);
  DualSignals(PassKey, Signals, True);
  SaveTiming(Sender);
  DualBlacklistParams(PassKey, True, tmpBL_Enabled, tmpAttempts, tmpTimeout, tmpDuration);
  {$I include\reg_crypt_end.inc}
end;

function TMainForm.DetectPlatform : Integer;
var
  osv : TOSVersionInfo;
begin
  osv.dwOSVersionInfoSize:=sizeOf(osv);
  GetVersionEx(osv);
  Result := osv.dwPlatformId;
end;

procedure TMainForm.DisableApplication(Sender: TObject);
begin
  Notebook.Pages.Delete(0);
  Notebook.Pages.Delete(0);
  Notebook.Pages.Delete(0);
  Notebook.Pages.Delete(0);
  Notebook.Pages.Delete(0);
  Notebook.Pages.Delete(0);

  Action1.OnExecute := nil;
  Action14.OnExecute := nil;
  Action15.OnExecute := nil;
  Action16.OnExecute := nil;
  Action19.Enabled := False;
end;

procedure TMainForm.Report(Sender: TObject);
var
  TF: TextFile;
begin
  try
    StringBuffer := ExtractFilePath(Paramstr(0)) + DateToStr(Date) + '.htm';
    AssignFile(TF, StringBuffer);
    Rewrite(TF);
    WriteLn(TF, '<html>');
    WriteLn(TF, '<head>');
    WriteLn(TF, '<title>Neo Blue SL</title>');
    WriteLn(TF, '</head>');
    WriteLn(TF, '<body text="Black" style="font-family: Verdana, Geneva, Arial, Helvetica, sans-serif; font-size: 10pt;" bgcolor="Silver">');

    WriteLn(TF, '<table bgcolor="Gray" cellspacing=0 cellpadding=0 border=0 width="100%" align="center">');
    WriteLn(TF, '<tr>');
    WriteLn(TF, '	<td width=10 height=10><font color="Gray">.</font></td>');
    WriteLn(TF, '	<td height=10><font color="Gray">.</font></td>');
    WriteLn(TF, '	<td width=10 height=10><font color="Gray">.</font></td>');
    WriteLn(TF, '</tr>');
    WriteLn(TF, '<tr>');
    WriteLn(TF, '	<td width=10><font color="Gray">.</font></td>');
    WriteLn(TF, '	<td><div align="left"><font color="White"  face="Arial, Helvetica, sans-serif" style="font-size: 22pt;"><b>' + StaticText1.Caption + '</b></font></div></td>');
    WriteLn(TF, '	<td width=10><font color="Gray">.</font></td>');
    WriteLn(TF, '</tr>');
    WriteLn(TF, '<tr>');
    WriteLn(TF, '	<td width=10 height=10><font color="Gray">.</font></td>');
    WriteLn(TF, '	<td height=10><font color="Gray">.</font></td>');
    WriteLn(TF, '	<td width=10 height=10><font color="Gray">.</font></td>');
    WriteLn(TF, '</tr>');
    WriteLn(TF, '</table>');

    WriteLn(TF, '<p align="center"><font color="Gray" face="Arial, Helvetica, sans-serif" style="font-size: 22pt;"><b>Neo Blue SL</b></font><br>');
    WriteLn(TF, '<font style="font-size: 14pt;" face="MS Sans Serif">Version 1.0</font></p>');

    WriteLn(TF, '<p align="left">Created: ' + DateToStr(Date) + ', ' + TimeToStr(Time) + '<br>');
    WriteLn(TF, 'Registered to: ' + StaticText17.Caption + '</p>');

    WriteLn(TF, '<p><font color="Gray" face="Arial, Helvetica, sans-serif" style="font-size: 16pt;"><b>General</b></font></p>');
    WriteLn(TF, '<BLOCKQUOTE>');
    WriteLn(TF, '<p align="left">');
    WriteLn(TF, Label1.Caption + ': ' + StaticText1.Caption + '<br>');
    WriteLn(TF, 'Platform: ');
    case DetectPlatform of
      VER_PLATFORM_WIN32s: Write(TF, 'Windows 3.*<br>');
      VER_PLATFORM_WIN32_WINDOWS: Write(TF, 'Windows 95/98/Me<br>');
      VER_PLATFORM_WIN32_NT: Write(TF, 'Windows NT/2000/XP<br>');
    end;
    WriteLn(TF, Label31.Caption + ': ' + StaticText12.Caption + '<br>');
    WriteLn(TF, Label2.Caption + ': ' + StaticText2.Caption + '<br>');
    if (StaticText11.Caption <> '') then WriteLn(TF, Label32.Caption + ': ' + StaticText11.Caption + '<br>');
    WriteLn(TF, Label5.Caption + ': ' + StaticText5.Caption + '<br>');
    WriteLn(TF, Label3.Caption + ': ' + StaticText3.Caption + '<br>');
    WriteLn(TF, Label6.Caption + ': ' + StaticText6.Caption + '<br>');
    WriteLn(TF, Label13.Caption + ': ' + StaticText9.Caption + '<br>');
    WriteLn(TF, '</p>');
    WriteLn(TF, '</BLOCKQUOTE>');
    WriteLn(TF, '</body>');
    WriteLn(TF, '</html>');
    CloseFile(TF);
    ShellExecute(Handle,'open',pChar(StringBuffer),'','',SW_SHOWNORMAL);
  except
    ShowMessage('Cannot create report!');
  end;
end;

procedure TMainForm.CloseNeoBlue(Sender: TObject; var CanClose: Boolean);
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(ExtractFilePath(Paramstr(0)) + Settings);
  Ini.WriteString('General', 'Left', IntToStr(MainForm.Left));
  Ini.WriteString('General', 'Top', IntToStr(MainForm.Top));
  Ini.Free;
end;

procedure TMainForm.LoadParams(Sender: TObject);
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(ExtractFilePath(Paramstr(0)) + Settings);
  if (Ini.ReadString('General', 'Left', IntToStr(MainForm.Left)) <> '') then MainForm.Left := StrToInt(Ini.ReadString('General', 'Left', IntToStr(MainForm.Left)));
  if (Ini.ReadString('General', 'Top', IntToStr(MainForm.Top)) <> '') then MainForm.Top := StrToInt(Ini.ReadString('General', 'Top', IntToStr(MainForm.Top)));
  Ini.Free;
end;

procedure TMainForm.TryRegister(Sender: TObject);
begin
  PasswordDlg.Show;
end;

procedure GetRegistrationInformation(NewUserName : PChar);stdcall
begin
  UserName := NewUserName;
end;
exports
  GetRegistrationInformation;

procedure TMainForm.Action20Execute(Sender: TObject);
begin
  ShellExecute(Handle,'open',pChar(Application.HelpFile),'','',SW_SHOW);
end;

end.
